package b4a.terminal;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.terminal", "b4a.terminal.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.terminal", "b4a.terminal.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.terminal.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.BleManager _manager = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static anywheresoftware.b4a.objects.BleManager.GattServiceWrapper _s = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _c = null;
public static int _connectstate = 0;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _bt = null;
public static int _cstatedisconnect = 0;
public static int _cstatepreconnect = 0;
public static int _cstateconnect = 0;
public static int _cstatepredisconnect = 0;
public static anywheresoftware.b4a.objects.BleManager.GattServiceWrapper _privserv = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _charread = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _charwrite = null;
public static String _readtext = "";
public static String _readstring = "";
public static String _sendtext = "";
public static String _sendstring = "";
public static boolean _readhex = false;
public static boolean _sendhex = false;
public anywheresoftware.b4a.objects.ButtonWrapper _button_connect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button_disconnect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button_send = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button_read = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button_sendhex = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button_readhex = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext_datasend = null;
public anywheresoftware.b4a.objects.EditTextWrapper _editinvisible = null;
public anywheresoftware.b4a.objects.LabelWrapper _label_dataread = null;
public anywheresoftware.b4a.objects.LabelWrapper _label_dr = null;
public anywheresoftware.b4a.objects.LabelWrapper _label_ds = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button_close = null;
public anywheresoftware.b4a.objects.LabelWrapper _label_wrok = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 83;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 //BA.debugLineNum = 85;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 86;BA.debugLine="BT.Initialize(\"BT\")";
_bt.Initialize(processBA,"BT");
 //BA.debugLineNum = 87;BA.debugLine="Timer1.Initialize(\"Timer\",500)";
_timer1.Initialize(processBA,"Timer",(long) (500));
 //BA.debugLineNum = 88;BA.debugLine="Timer1.Enabled=True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 90;BA.debugLine="Manager.Initialize(\"ble\")";
_manager.Initialize(processBA,"ble");
 //BA.debugLineNum = 91;BA.debugLine="Button_Disconnect.Enabled = False";
mostCurrent._button_disconnect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 92;BA.debugLine="Button_Connect.Enabled = True";
mostCurrent._button_connect.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 93;BA.debugLine="Button_Read.Enabled = False";
mostCurrent._button_read.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 94;BA.debugLine="Button_Send.Enabled = False";
mostCurrent._button_send.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 95;BA.debugLine="ConnectState = cstateDisconnect";
_connectstate = _cstatedisconnect;
 };
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 102;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 99;BA.debugLine="Sub Activity_Resume()";
 //BA.debugLineNum = 100;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicchanged(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
 //BA.debugLineNum = 186;BA.debugLine="Sub ble_CharacteristicChanged (Characteristic As BleCharacteristic)";
 //BA.debugLineNum = 187;BA.debugLine="Log(\"ble_CharacteristicChanged\")";
anywheresoftware.b4a.keywords.Common.Log("ble_CharacteristicChanged");
 //BA.debugLineNum = 188;BA.debugLine="Log(\"  Change: \" & Characteristic.GetIntValue(Characteristic.FORMAT_UINT8,0) &CRLF &CRLF)	'Get one byte";
anywheresoftware.b4a.keywords.Common.Log("  Change: "+BA.NumberToString(_characteristic.GetIntValue(_characteristic.FORMAT_UINT8,(int) (0)))+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 189;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicread(boolean _success,anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
 //BA.debugLineNum = 169;BA.debugLine="Sub ble_CharacteristicRead (Success As Boolean, Characteristic As BleCharacteristic)";
 //BA.debugLineNum = 174;BA.debugLine="Log(\"ble_CharacteristicRead\")";
anywheresoftware.b4a.keywords.Common.Log("ble_CharacteristicRead");
 //BA.debugLineNum = 175;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 176;BA.debugLine="Log(\"  Data read: \" & Characteristic.GetStringValue(0) &CRLF &CRLF)";
anywheresoftware.b4a.keywords.Common.Log("  Data read: "+_characteristic.GetStringValue((int) (0))+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 177;BA.debugLine="ReadText = Characteristic.GetStringValue(0)";
_readtext = _characteristic.GetStringValue((int) (0));
 //BA.debugLineNum = 180;BA.debugLine="If readHex = True Then ReadString = ByteToHex(ReadText)	Else ReadString = ReadText";
if (_readhex==anywheresoftware.b4a.keywords.Common.True) { 
_readstring = _bytetohex(_readtext);}
else {
_readstring = _readtext;};
 //BA.debugLineNum = 181;BA.debugLine="Label_DataRead.Text = ReadString";
mostCurrent._label_dataread.setText((Object)(_readstring));
 //BA.debugLineNum = 182;BA.debugLine="Label_DR.Text = \"Data read: \" &ReadText.Length";
mostCurrent._label_dr.setText((Object)("Data read: "+BA.NumberToString(_readtext.length())));
 };
 //BA.debugLineNum = 184;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicwrite(boolean _success,anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
 //BA.debugLineNum = 191;BA.debugLine="Sub ble_CharacteristicWrite (Success As Boolean, Characteristic As BleCharacteristic)";
 //BA.debugLineNum = 192;BA.debugLine="Log(\"ble_CharacteristicWrite\")";
anywheresoftware.b4a.keywords.Common.Log("ble_CharacteristicWrite");
 //BA.debugLineNum = 193;BA.debugLine="Log(\"  Data sent: \" & SendString)	'";
anywheresoftware.b4a.keywords.Common.Log("  Data sent: "+_sendstring);
 //BA.debugLineNum = 194;BA.debugLine="Log(\"  Write Success \"& Success &CRLF &CRLF)";
anywheresoftware.b4a.keywords.Common.Log("  Write Success "+BA.ObjectToString(_success)+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 198;BA.debugLine="If Success = True Then";
if (_success==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 199;BA.debugLine="Label_wrok.Color = Colors.RGB(0,128,0)";
mostCurrent._label_wrok.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (0),(int) (128),(int) (0)));
 //BA.debugLineNum = 200;BA.debugLine="Label_wrok.Text = \"Write OK\"";
mostCurrent._label_wrok.setText((Object)("Write OK"));
 }else {
 //BA.debugLineNum = 202;BA.debugLine="Label_wrok.Color = Colors.Red";
mostCurrent._label_wrok.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 203;BA.debugLine="Label_wrok.Text = \"Write Failed !\"";
mostCurrent._label_wrok.setText((Object)("Write Failed !"));
 };
 //BA.debugLineNum = 206;BA.debugLine="Label_wrok.Visible = True";
mostCurrent._label_wrok.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 207;BA.debugLine="Delay(500,True)";
_delay((long) (500),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 208;BA.debugLine="Label_wrok.Visible = False";
mostCurrent._label_wrok.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 210;BA.debugLine="End Sub";
return "";
}
public static String  _ble_connected(anywheresoftware.b4a.objects.collections.Map _services) throws Exception{
int _i = 0;
int _j = 0;
int _n = 0;
int _cw = 0;
int _cr = 0;
 //BA.debugLineNum = 117;BA.debugLine="Sub ble_Connected (Services As Map)";
 //BA.debugLineNum = 118;BA.debugLine="Dim i,j,n,cw,cr As Int";
_i = 0;
_j = 0;
_n = 0;
_cw = 0;
_cr = 0;
 //BA.debugLineNum = 126;BA.debugLine="If ConnectState==cstatePreConnect Then";
if (_connectstate==_cstatepreconnect) { 
 //BA.debugLineNum = 127;BA.debugLine="ConnectState = cstateConnect";
_connectstate = _cstateconnect;
 //BA.debugLineNum = 129;BA.debugLine="Log(\"Connected\" &CRLF &CRLF)";
anywheresoftware.b4a.keywords.Common.Log("Connected"+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 130;BA.debugLine="Button_Disconnect.Enabled = True";
mostCurrent._button_disconnect.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 131;BA.debugLine="Button_Connect.Enabled = False";
mostCurrent._button_connect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 136;BA.debugLine="For i = 0 To  Services.Size - 1";
{
final int step69 = 1;
final int limit69 = (int) (_services.getSize()-1);
for (_i = (int) (0); (step69 > 0 && _i <= limit69) || (step69 < 0 && _i >= limit69); _i = ((int)(0 + _i + step69))) {
 //BA.debugLineNum = 137;BA.debugLine="s = Services.GetValueAt(i)";
_s.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt(_i)));
 //BA.debugLineNum = 138;BA.debugLine="Log(\"Service[\" & i & \"]: \" & Services.GetKeyAt(i) &CRLF &CRLF)	' Log the UUID of the selected Service";
anywheresoftware.b4a.keywords.Common.Log("Service["+BA.NumberToString(_i)+"]: "+BA.ObjectToString(_services.GetKeyAt(_i))+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 139;BA.debugLine="For j = 0 To  s.GetCharacteristics.Size - 1";
{
final int step72 = 1;
final int limit72 = (int) (_s.GetCharacteristics().getSize()-1);
for (_j = (int) (0); (step72 > 0 && _j <= limit72) || (step72 < 0 && _j >= limit72); _j = ((int)(0 + _j + step72))) {
 //BA.debugLineNum = 140;BA.debugLine="c  = s.GetCharacteristics.GetValueAt(j)";
_c.setObject((android.bluetooth.BluetoothGattCharacteristic)(_s.GetCharacteristics().GetValueAt(_j)));
 //BA.debugLineNum = 141;BA.debugLine="Log(\"      C[\" & j &\"]: Uuid \" & c.Uuid)";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: Uuid "+_c.getUuid());
 //BA.debugLineNum = 142;BA.debugLine="Log(\"      C[\" & j &\"]: Permissions\" & BleCharacteristicPermissionsToString(c))";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: Permissions"+_blecharacteristicpermissionstostring(_c));
 //BA.debugLineNum = 143;BA.debugLine="Log(\"      C[\" & j &\"]: Properties \" & BleCharacteristicPropertiesToString(c))";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: Properties "+_blecharacteristicpropertiestostring(_c));
 //BA.debugLineNum = 144;BA.debugLine="Log(\"      C[\" & j &\"]: WriteType  \" & BleCharacteristicWriteTypeToString(c) &CRLF &CRLF)";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: WriteType  "+_blecharacteristicwritetypetostring(_c)+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 }
};
 }
};
 //BA.debugLineNum = 147;BA.debugLine="Log (\"Number of Services: \" & Services.Size &CRLF &CRLF)";
anywheresoftware.b4a.keywords.Common.Log("Number of Services: "+BA.NumberToString(_services.getSize())+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 150;BA.debugLine="n = 2						                   		' service #2 is the private service";
_n = (int) (2);
 //BA.debugLineNum = 151;BA.debugLine="PrivServ = Services.GetValueAt(n)";
_privserv.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt(_n)));
 //BA.debugLineNum = 152;BA.debugLine="Log(\"PrivServ[\" & n & \"]: \" & Services.GetKeyAt(n))	' Log the UUID of the selected Service";
anywheresoftware.b4a.keywords.Common.Log("PrivServ["+BA.NumberToString(_n)+"]: "+BA.ObjectToString(_services.GetKeyAt(_n)));
 //BA.debugLineNum = 154;BA.debugLine="cr = 0                                   				' characteristic #0 is for the read channel";
_cr = (int) (0);
 //BA.debugLineNum = 155;BA.debugLine="CharRead = PrivServ.GetCharacteristics.GetValueAt(cr)";
_charread.setObject((android.bluetooth.BluetoothGattCharacteristic)(_privserv.GetCharacteristics().GetValueAt(_cr)));
 //BA.debugLineNum = 156;BA.debugLine="Log(\"CharRead:    \" & CharRead.Uuid)					' Log the UUID of the selected characteristic";
anywheresoftware.b4a.keywords.Common.Log("CharRead:    "+_charread.getUuid());
 //BA.debugLineNum = 159;BA.debugLine="cw = 0													' default: characteristic #0 is also for the write channel";
_cw = (int) (0);
 //BA.debugLineNum = 160;BA.debugLine="CharWrite = PrivServ.GetCharacteristics.GetValueAt(cw)";
_charwrite.setObject((android.bluetooth.BluetoothGattCharacteristic)(_privserv.GetCharacteristics().GetValueAt(_cw)));
 //BA.debugLineNum = 161;BA.debugLine="Log(\"Charwrite:   \" & CharWrite.Uuid &CRLF &CRLF)		' Log the UUID of the selected characteristic";
anywheresoftware.b4a.keywords.Common.Log("Charwrite:   "+_charwrite.getUuid()+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 163;BA.debugLine="Button_Read.Enabled = True";
mostCurrent._button_read.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 164;BA.debugLine="Button_Send.Enabled = True";
mostCurrent._button_send.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}
public static String  _ble_devicefound(String _name,String _macaddress) throws Exception{
 //BA.debugLineNum = 105;BA.debugLine="Sub ble_DeviceFound (Name As String, MacAddress As String)";
 //BA.debugLineNum = 106;BA.debugLine="Log(Name & \", \" & MacAddress)";
anywheresoftware.b4a.keywords.Common.Log(_name+", "+_macaddress);
 //BA.debugLineNum = 107;BA.debugLine="Log(\"Connecting...\")";
anywheresoftware.b4a.keywords.Common.Log("Connecting...");
 //BA.debugLineNum = 111;BA.debugLine="If ConnectState == cstateDisconnect Then";
if (_connectstate==_cstatedisconnect) { 
 //BA.debugLineNum = 112;BA.debugLine="ConnectState = cstatePreConnect        ' change state to prevent an other call to manager.ConnectState";
_connectstate = _cstatepreconnect;
 //BA.debugLineNum = 113;BA.debugLine="Manager.Connect(MacAddress, False)";
_manager.Connect(_macaddress,anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
public static String  _ble_disconnected() throws Exception{
 //BA.debugLineNum = 212;BA.debugLine="Sub ble_Disconnected";
 //BA.debugLineNum = 214;BA.debugLine="ConnectState = cstateDisconnect										 '";
_connectstate = _cstatedisconnect;
 //BA.debugLineNum = 215;BA.debugLine="Manager.Close               	'it is important to also close the disconnected device";
_manager.Close();
 //BA.debugLineNum = 217;BA.debugLine="Button_Read.Enabled = False	'If the BLE connection has been broken up, using these buttons will throw an exception";
mostCurrent._button_read.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 218;BA.debugLine="Button_Send.Enabled = False";
mostCurrent._button_send.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 220;BA.debugLine="Log(\"ble_Disconnected\")";
anywheresoftware.b4a.keywords.Common.Log("ble_Disconnected");
 //BA.debugLineNum = 221;BA.debugLine="End Sub";
return "";
}
public static String  _ble_discoveryfinished() throws Exception{
 //BA.debugLineNum = 223;BA.debugLine="Sub ble_DiscoveryFinished";
 //BA.debugLineNum = 224;BA.debugLine="Log(\"ble_DiscoveryFinished\")";
anywheresoftware.b4a.keywords.Common.Log("ble_DiscoveryFinished");
 //BA.debugLineNum = 225;BA.debugLine="Log(\"State \" & ConnectState)";
anywheresoftware.b4a.keywords.Common.Log("State "+BA.NumberToString(_connectstate));
 //BA.debugLineNum = 226;BA.debugLine="Log(\"ble_DiscoveryFinished ende\")";
anywheresoftware.b4a.keywords.Common.Log("ble_DiscoveryFinished ende");
 //BA.debugLineNum = 227;BA.debugLine="End Sub";
return "";
}
public static String  _ble_newrssivalue(String _macaddress,int _newrsii) throws Exception{
 //BA.debugLineNum = 229;BA.debugLine="Sub  ble_NewRssiValue (MacAddress As String,NewRsii As Int)";
 //BA.debugLineNum = 230;BA.debugLine="Log(\"ble_NewRssiValue\")";
anywheresoftware.b4a.keywords.Common.Log("ble_NewRssiValue");
 //BA.debugLineNum = 231;BA.debugLine="Log(\"Rssi \" & NewRsii)";
anywheresoftware.b4a.keywords.Common.Log("Rssi "+BA.NumberToString(_newrsii));
 //BA.debugLineNum = 232;BA.debugLine="End Sub";
return "";
}
public static String  _blecharacteristicpermissionstostring(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cha) throws Exception{
anywheresoftware.b4a.keywords.StringBuilderWrapper _output = null;
 //BA.debugLineNum = 402;BA.debugLine="Sub BleCharacteristicPermissionsToString ( Cha As BleCharacteristic) As String";
 //BA.debugLineNum = 404;BA.debugLine="Dim Output As StringBuilder";
_output = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 406;BA.debugLine="Output.Initialize";
_output.Initialize();
 //BA.debugLineNum = 408;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_READ) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_READ)!=0) { 
 //BA.debugLineNum = 409;BA.debugLine="Output.Append(\"Read \")";
_output.Append("Read ");
 };
 //BA.debugLineNum = 411;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_READ_ENCRYPTED) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_READ_ENCRYPTED)!=0) { 
 //BA.debugLineNum = 412;BA.debugLine="Output.Append(\"READ_ENCRYPTED \")";
_output.Append("READ_ENCRYPTED ");
 };
 //BA.debugLineNum = 414;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_READ_ENCRYPTED_MITM)  <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_READ_ENCRYPTED_MITM)!=0) { 
 //BA.debugLineNum = 415;BA.debugLine="Output.Append(\"Read_E_MITM \")";
_output.Append("Read_E_MITM ");
 };
 //BA.debugLineNum = 417;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE)!=0) { 
 //BA.debugLineNum = 418;BA.debugLine="Output.Append(\"Write \")";
_output.Append("Write ");
 };
 //BA.debugLineNum = 420;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE_ENCRYPTED)  <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE_ENCRYPTED)!=0) { 
 //BA.debugLineNum = 421;BA.debugLine="Output.Append(\"Write_ENCRYPTED \")";
_output.Append("Write_ENCRYPTED ");
 };
 //BA.debugLineNum = 423;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE)!=0) { 
 //BA.debugLineNum = 424;BA.debugLine="Output.Append(\"Write_E_MITM \")";
_output.Append("Write_E_MITM ");
 };
 //BA.debugLineNum = 426;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE_SIGNED) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE_SIGNED)!=0) { 
 //BA.debugLineNum = 427;BA.debugLine="Output.Append(\"Write_SIGNED \")";
_output.Append("Write_SIGNED ");
 };
 //BA.debugLineNum = 429;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE_SIGNED_MITM) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE_SIGNED_MITM)!=0) { 
 //BA.debugLineNum = 430;BA.debugLine="Output.Append(\"Write_S_MITM \")";
_output.Append("Write_S_MITM ");
 };
 //BA.debugLineNum = 433;BA.debugLine="Return Output.ToString";
if (true) return _output.ToString();
 //BA.debugLineNum = 435;BA.debugLine="End Sub";
return "";
}
public static String  _blecharacteristicpropertiestostring(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cha) throws Exception{
anywheresoftware.b4a.keywords.StringBuilderWrapper _output = null;
 //BA.debugLineNum = 437;BA.debugLine="Sub BleCharacteristicPropertiesToString ( Cha As BleCharacteristic) As String";
 //BA.debugLineNum = 438;BA.debugLine="Dim Output As StringBuilder";
_output = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 440;BA.debugLine="Output.Initialize";
_output.Initialize();
 //BA.debugLineNum = 441;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_BROADCAST) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_BROADCAST)!=0) { 
 //BA.debugLineNum = 442;BA.debugLine="Output.Append(\"BROADCAST \")";
_output.Append("BROADCAST ");
 };
 //BA.debugLineNum = 444;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_EXTENDED_PROPS) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_EXTENDED_PROPS)!=0) { 
 //BA.debugLineNum = 445;BA.debugLine="Output.Append(\"EXTENDED_PROPS \")";
_output.Append("EXTENDED_PROPS ");
 };
 //BA.debugLineNum = 447;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_INDICATE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_INDICATE)!=0) { 
 //BA.debugLineNum = 448;BA.debugLine="Output.Append(\"EXTENDED_INDICATE \")";
_output.Append("EXTENDED_INDICATE ");
 };
 //BA.debugLineNum = 450;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_NOTIFY) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_NOTIFY)!=0) { 
 //BA.debugLineNum = 451;BA.debugLine="Output.Append(\"NOTIFY \")";
_output.Append("NOTIFY ");
 };
 //BA.debugLineNum = 453;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_READ) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_READ)!=0) { 
 //BA.debugLineNum = 454;BA.debugLine="Output.Append(\"READ \")";
_output.Append("READ ");
 };
 //BA.debugLineNum = 456;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_SIGNED_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_SIGNED_WRITE)!=0) { 
 //BA.debugLineNum = 457;BA.debugLine="Output.Append(\"SIGNED_WRITE \")";
_output.Append("SIGNED_WRITE ");
 };
 //BA.debugLineNum = 459;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_WRITE)!=0) { 
 //BA.debugLineNum = 460;BA.debugLine="Output.Append(\"WRITE \")";
_output.Append("WRITE ");
 };
 //BA.debugLineNum = 462;BA.debugLine="If Bit.AND(Cha.Properties , Cha.PROPERTY_WRITE_NO_RESPONSE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_WRITE_NO_RESPONSE)!=0) { 
 //BA.debugLineNum = 463;BA.debugLine="Output.Append(\"WRITE_NO_RESPONSE \")";
_output.Append("WRITE_NO_RESPONSE ");
 };
 //BA.debugLineNum = 466;BA.debugLine="Return Output.ToString";
if (true) return _output.ToString();
 //BA.debugLineNum = 468;BA.debugLine="End Sub";
return "";
}
public static String  _blecharacteristicwritetypetostring(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cha) throws Exception{
anywheresoftware.b4a.keywords.StringBuilderWrapper _output = null;
 //BA.debugLineNum = 470;BA.debugLine="Sub BleCharacteristicWriteTypeToString ( Cha As BleCharacteristic) As String";
 //BA.debugLineNum = 471;BA.debugLine="Dim Output As StringBuilder";
_output = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 473;BA.debugLine="Output.Initialize";
_output.Initialize();
 //BA.debugLineNum = 474;BA.debugLine="If Bit.AND(Cha.WriteType , Cha.WRITE_TYPE_DEFAULT) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getWriteType(),_cha.WRITE_TYPE_DEFAULT)!=0) { 
 //BA.debugLineNum = 475;BA.debugLine="Output.Append(\"TYPE_DEFAULT \")";
_output.Append("TYPE_DEFAULT ");
 };
 //BA.debugLineNum = 477;BA.debugLine="If Bit.AND(Cha.WriteType , Cha.WRITE_TYPE_NO_RESPONSE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getWriteType(),_cha.WRITE_TYPE_NO_RESPONSE)!=0) { 
 //BA.debugLineNum = 478;BA.debugLine="Output.Append(\"TYPE_NO_RESPONSE \")";
_output.Append("TYPE_NO_RESPONSE ");
 };
 //BA.debugLineNum = 480;BA.debugLine="If Bit.AND(Cha.WriteType , Cha.WRITE_TYPE_SIGNED) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getWriteType(),_cha.WRITE_TYPE_SIGNED)!=0) { 
 //BA.debugLineNum = 481;BA.debugLine="Output.Append(\"TYPE_SIGNED \")";
_output.Append("TYPE_SIGNED ");
 };
 //BA.debugLineNum = 484;BA.debugLine="Return Output.ToString";
if (true) return _output.ToString();
 //BA.debugLineNum = 485;BA.debugLine="End Sub";
return "";
}
public static String  _button_close_click() throws Exception{
 //BA.debugLineNum = 292;BA.debugLine="Sub Button_Close_Click	'Close the EditText_DataSend. Closing on ..._EnterPressed appends an unwanted character 10 sometimes.";
 //BA.debugLineNum = 294;BA.debugLine="SendText = EditText_DataSend.Text";
_sendtext = mostCurrent._edittext_datasend.getText();
 //BA.debugLineNum = 296;BA.debugLine="Log(\"Data to send: \" &SendText)";
anywheresoftware.b4a.keywords.Common.Log("Data to send: "+_sendtext);
 //BA.debugLineNum = 297;BA.debugLine="EditInvisible.RequestFocus		'Tricky: to remove the focus from the current view, set it to a (useless)";
mostCurrent._editinvisible.RequestFocus();
 //BA.debugLineNum = 300;BA.debugLine="If sendHex = True Then SendString = HextoByte(SendText) Else SendString = SendText";
if (_sendhex==anywheresoftware.b4a.keywords.Common.True) { 
_sendstring = _hextobyte(_sendtext);}
else {
_sendstring = _sendtext;};
 //BA.debugLineNum = 301;BA.debugLine="Label_DS.Text = \"Data to send: \" &SendString.Length";
mostCurrent._label_ds.setText((Object)("Data to send: "+BA.NumberToString(_sendstring.length())));
 //BA.debugLineNum = 303;BA.debugLine="If ConnectState = cstateConnect Then Button_Send.Enabled = True";
if (_connectstate==_cstateconnect) { 
mostCurrent._button_send.setEnabled(anywheresoftware.b4a.keywords.Common.True);};
 //BA.debugLineNum = 305;BA.debugLine="End Sub";
return "";
}
public static String  _button_connect_click() throws Exception{
 //BA.debugLineNum = 249;BA.debugLine="Sub Button_Connect_Click";
 //BA.debugLineNum = 250;BA.debugLine="Log(\"Start Discover\")";
anywheresoftware.b4a.keywords.Common.Log("Start Discover");
 //BA.debugLineNum = 252;BA.debugLine="If Not(BT.IsEnabled) Then";
if (anywheresoftware.b4a.keywords.Common.Not(_bt.IsEnabled())) { 
 //BA.debugLineNum = 253;BA.debugLine="BT.Enable";
_bt.Enable();
 //BA.debugLineNum = 254;BA.debugLine="Delay(1500,True)";
_delay((long) (1500),anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 257;BA.debugLine="ConnectState = cstateDisconnect";
_connectstate = _cstatedisconnect;
 //BA.debugLineNum = 258;BA.debugLine="If  (Manager.BleSupported) Then";
if ((_manager.getBleSupported())) { 
 //BA.debugLineNum = 259;BA.debugLine="Manager.Scan(3000, Null)		'Scan BLE peripherals for 10s";
_manager.Scan(processBA,(long) (3000),(String[])(anywheresoftware.b4a.keywords.Common.Null));
 }else {
 //BA.debugLineNum = 261;BA.debugLine="Button_Disconnect_Click";
_button_disconnect_click();
 //BA.debugLineNum = 262;BA.debugLine="ToastMessageShow( \"Sorry no Bluetooth 4 support found\" ,True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Sorry no Bluetooth 4 support found",anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 265;BA.debugLine="End Sub";
return "";
}
public static String  _button_disconnect_click() throws Exception{
 //BA.debugLineNum = 234;BA.debugLine="Sub Button_Disconnect_Click					     ' Disconnect";
 //BA.debugLineNum = 238;BA.debugLine="Manager.Disconnect";
_manager.Disconnect();
 //BA.debugLineNum = 240;BA.debugLine="ConnectState = cstatePreDisconnect";
_connectstate = _cstatepredisconnect;
 //BA.debugLineNum = 242;BA.debugLine="Button_Disconnect.Enabled = False";
mostCurrent._button_disconnect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 243;BA.debugLine="Button_Connect.Enabled = True";
mostCurrent._button_connect.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 244;BA.debugLine="Button_Read.Enabled = False";
mostCurrent._button_read.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 245;BA.debugLine="Button_Send.Enabled = False";
mostCurrent._button_send.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 247;BA.debugLine="End Sub";
return "";
}
public static String  _button_read_click() throws Exception{
 //BA.debugLineNum = 277;BA.debugLine="Sub Button_Read_Click	'Read data";
 //BA.debugLineNum = 279;BA.debugLine="Manager.ReadCharacteristic(CharRead)";
_manager.ReadCharacteristic(_charread);
 //BA.debugLineNum = 281;BA.debugLine="End Sub";
return "";
}
public static String  _button_readhex_click() throws Exception{
 //BA.debugLineNum = 328;BA.debugLine="Sub Button_ReadHex_Click	'Toggle between data to show as received (bytes as characters),";
 //BA.debugLineNum = 330;BA.debugLine="If readHex = False Then";
if (_readhex==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 331;BA.debugLine="Button_ReadHex.Text = \"Show as HEX\"";
mostCurrent._button_readhex.setText((Object)("Show as HEX"));
 //BA.debugLineNum = 332;BA.debugLine="Button_ReadHex.Color = Colors.Blue";
mostCurrent._button_readhex.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 333;BA.debugLine="readHex = True";
_readhex = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 334;BA.debugLine="ReadString = ByteToHex(ReadText)";
_readstring = _bytetohex(_readtext);
 }else {
 //BA.debugLineNum = 336;BA.debugLine="Button_ReadHex.Text = \"Show as Byte\"";
mostCurrent._button_readhex.setText((Object)("Show as Byte"));
 //BA.debugLineNum = 337;BA.debugLine="Button_ReadHex.Color = Colors.DarkGray";
mostCurrent._button_readhex.setColor(anywheresoftware.b4a.keywords.Common.Colors.DarkGray);
 //BA.debugLineNum = 338;BA.debugLine="readHex = False";
_readhex = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 339;BA.debugLine="ReadString = ReadText";
_readstring = _readtext;
 };
 //BA.debugLineNum = 342;BA.debugLine="Label_DataRead.Text = ReadString";
mostCurrent._label_dataread.setText((Object)(_readstring));
 //BA.debugLineNum = 344;BA.debugLine="End Sub";
return "";
}
public static String  _button_send_click() throws Exception{
 //BA.debugLineNum = 267;BA.debugLine="Sub Button_Send_Click	'Send data";
 //BA.debugLineNum = 272;BA.debugLine="CharWrite.SetStringValue(SendString)  	' first write it to charateristic locally";
_charwrite.SetStringValue(_sendstring);
 //BA.debugLineNum = 273;BA.debugLine="Manager.WriteCharacteristic(CharWrite)	' then write/sent it to the device";
_manager.WriteCharacteristic(_charwrite);
 //BA.debugLineNum = 275;BA.debugLine="End Sub";
return "";
}
public static String  _button_sendhex_click() throws Exception{
 //BA.debugLineNum = 307;BA.debugLine="Sub Button_SendHex_Click	'Toggle between data to send as is (characters as bytes), or translated from hex numbers to bytes.";
 //BA.debugLineNum = 313;BA.debugLine="If sendHex = False Then";
if (_sendhex==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 314;BA.debugLine="Button_SendHex.Text = \"HEX to Byte\"";
mostCurrent._button_sendhex.setText((Object)("HEX to Byte"));
 //BA.debugLineNum = 315;BA.debugLine="Button_SendHex.Color = Colors.Blue";
mostCurrent._button_sendhex.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 316;BA.debugLine="sendHex = True";
_sendhex = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 317;BA.debugLine="SendString = HextoByte(SendText)";
_sendstring = _hextobyte(_sendtext);
 }else {
 //BA.debugLineNum = 319;BA.debugLine="Button_SendHex.Text = \"Send as Byte\"";
mostCurrent._button_sendhex.setText((Object)("Send as Byte"));
 //BA.debugLineNum = 320;BA.debugLine="Button_SendHex.Color = Colors.DarkGray";
mostCurrent._button_sendhex.setColor(anywheresoftware.b4a.keywords.Common.Colors.DarkGray);
 //BA.debugLineNum = 321;BA.debugLine="sendHex = False";
_sendhex = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 322;BA.debugLine="SendString = SendText";
_sendstring = _sendtext;
 };
 //BA.debugLineNum = 325;BA.debugLine="Label_DS.Text = \"Data to send: \" &SendString.Length";
mostCurrent._label_ds.setText((Object)("Data to send: "+BA.NumberToString(_sendstring.length())));
 //BA.debugLineNum = 327;BA.debugLine="End Sub";
return "";
}
public static String  _bytetohex(String _str) throws Exception{
byte _n = (byte)0;
byte[] _h = null;
String _s1 = "";
String _s2 = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bycon = null;
 //BA.debugLineNum = 346;BA.debugLine="Sub ByteToHex(str As String) As String	'Convert string of bytes to string of hex numbers with spaces";
 //BA.debugLineNum = 348;BA.debugLine="Dim n, h() As Byte";
_n = (byte)0;
_h = new byte[(int) (0)];
;
 //BA.debugLineNum = 349;BA.debugLine="Dim s1, s2 As String";
_s1 = "";
_s2 = "";
 //BA.debugLineNum = 350;BA.debugLine="Dim ByCon As ByteConverter";
_bycon = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 352;BA.debugLine="For n = 0 To str.Length -1";
{
final int step211 = 1;
final int limit211 = (byte) (_str.length()-1);
for (_n = (byte) (0); (step211 > 0 && _n <= limit211) || (step211 < 0 && _n >= limit211); _n = ((byte)(0 + _n + step211))) {
 //BA.debugLineNum = 353;BA.debugLine="h = ByCon.StringToBytes(ReadText.CharAt(n),\"ISO-8859-1\")";
_h = _bycon.StringToBytes(BA.ObjectToString(_readtext.charAt((int) (_n))),"ISO-8859-1");
 //BA.debugLineNum = 354;BA.debugLine="s1 = ByCon.HexFromBytes(h)";
_s1 = _bycon.HexFromBytes(_h);
 //BA.debugLineNum = 355;BA.debugLine="s2 = s2 &s1 &\" \"";
_s2 = _s2+_s1+" ";
 }
};
 //BA.debugLineNum = 358;BA.debugLine="Return s2";
if (true) return _s2;
 //BA.debugLineNum = 360;BA.debugLine="End Sub";
return "";
}
public static String  _delay(long _nmillisecond,boolean _enableevents) throws Exception{
long _nbegintime = 0L;
long _nendtime = 0L;
 //BA.debugLineNum = 380;BA.debugLine="Sub Delay(nMilliSecond As Long, EnableEvents As Boolean)";
 //BA.debugLineNum = 381;BA.debugLine="Dim nBeginTime As Long";
_nbegintime = 0L;
 //BA.debugLineNum = 382;BA.debugLine="Dim nEndTime As Long";
_nendtime = 0L;
 //BA.debugLineNum = 383;BA.debugLine="nEndTime = DateTime.Now + nMilliSecond";
_nendtime = (long) (anywheresoftware.b4a.keywords.Common.DateTime.getNow()+_nmillisecond);
 //BA.debugLineNum = 384;BA.debugLine="nBeginTime = DateTime.Now";
_nbegintime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 385;BA.debugLine="Do While nBeginTime < nEndTime";
while (_nbegintime<_nendtime) {
 //BA.debugLineNum = 386;BA.debugLine="nBeginTime = DateTime.Now";
_nbegintime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 388;BA.debugLine="If nEndTime < nBeginTime Then";
if (_nendtime<_nbegintime) { 
 //BA.debugLineNum = 389;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 391;BA.debugLine="If (EnableEvents) Then";
if ((_enableevents)) { 
 //BA.debugLineNum = 392;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 };
 }
;
 //BA.debugLineNum = 395;BA.debugLine="End Sub";
return "";
}
public static String  _edittext_datasend_textchanged(String _old,String _new) throws Exception{
 //BA.debugLineNum = 283;BA.debugLine="Sub EditText_DataSend_TextChanged (Old As String, New As String)";
 //BA.debugLineNum = 285;BA.debugLine="If EditText_DataSend.Text <> SendText Then Button_Send.Enabled = False";
if ((mostCurrent._edittext_datasend.getText()).equals(_sendtext) == false) { 
mostCurrent._button_send.setEnabled(anywheresoftware.b4a.keywords.Common.False);};
 //BA.debugLineNum = 287;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 62;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 66;BA.debugLine="Private Button_Connect As Button";
mostCurrent._button_connect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 67;BA.debugLine="Private Button_Disconnect As Button";
mostCurrent._button_disconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 68;BA.debugLine="Private Button_Send As Button";
mostCurrent._button_send = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 69;BA.debugLine="Private Button_Read As Button";
mostCurrent._button_read = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 70;BA.debugLine="Private Button_SendHex As Button";
mostCurrent._button_sendhex = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 71;BA.debugLine="Private Button_ReadHex As Button";
mostCurrent._button_readhex = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 72;BA.debugLine="Private EditText_DataSend As EditText";
mostCurrent._edittext_datasend = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 73;BA.debugLine="Private EditInvisible As EditText";
mostCurrent._editinvisible = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 74;BA.debugLine="Private Label_DataRead As Label";
mostCurrent._label_dataread = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 75;BA.debugLine="Private Label_DR As Label";
mostCurrent._label_dr = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 76;BA.debugLine="Private Label_DS As Label";
mostCurrent._label_ds = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 77;BA.debugLine="Private Button_Close As Button";
mostCurrent._button_close = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 78;BA.debugLine="Private Label_wrok As Label";
mostCurrent._label_wrok = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _hextobyte(String _str) throws Exception{
byte _n = (byte)0;
byte[] _h = null;
String _s1 = "";
String _s2 = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bycon = null;
 //BA.debugLineNum = 362;BA.debugLine="Sub HextoByte(str As String) As String	'Convert string of hex numbers to string of bytes, removing spaces";
 //BA.debugLineNum = 364;BA.debugLine="Dim n, h() As Byte";
_n = (byte)0;
_h = new byte[(int) (0)];
;
 //BA.debugLineNum = 365;BA.debugLine="Dim s1, s2 As String";
_s1 = "";
_s2 = "";
 //BA.debugLineNum = 366;BA.debugLine="Dim ByCon As ByteConverter";
_bycon = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 368;BA.debugLine="s1 = str.Replace(\" \",\"\")";
_s1 = _str.replace(" ","");
 //BA.debugLineNum = 369;BA.debugLine="s1 = s1.ToUpperCase";
_s1 = _s1.toUpperCase();
 //BA.debugLineNum = 371;BA.debugLine="For n = 0 To s1.Length -2 Step 2";
{
final int step224 = (byte) (2);
final int limit224 = (byte) (_s1.length()-2);
for (_n = (byte) (0); (step224 > 0 && _n <= limit224) || (step224 < 0 && _n >= limit224); _n = ((byte)(0 + _n + step224))) {
 //BA.debugLineNum = 372;BA.debugLine="h = ByCon.HexToBytes(s1.SubString2(n,n+2))";
_h = _bycon.HexToBytes(_s1.substring((int) (_n),(int) (_n+2)));
 //BA.debugLineNum = 373;BA.debugLine="s2 = s2 &ByCon.StringFromBytes(h,\"ISO-8859-1\")";
_s2 = _s2+_bycon.StringFromBytes(_h,"ISO-8859-1");
 }
};
 //BA.debugLineNum = 376;BA.debugLine="Return s2";
if (true) return _s2;
 //BA.debugLineNum = 378;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 36;BA.debugLine="Dim Manager As BleManager";
_manager = new anywheresoftware.b4a.objects.BleManager();
 //BA.debugLineNum = 37;BA.debugLine="Dim Timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 39;BA.debugLine="Dim s As BleService";
_s = new anywheresoftware.b4a.objects.BleManager.GattServiceWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim c As BleCharacteristic";
_c = new anywheresoftware.b4a.objects.BleManager.GattCharacteristic();
 //BA.debugLineNum = 42;BA.debugLine="Dim ConnectState As Int";
_connectstate = 0;
 //BA.debugLineNum = 43;BA.debugLine="Dim BT As BluetoothAdmin";
_bt = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 45;BA.debugLine="Dim cstateDisconnect As Int = 0";
_cstatedisconnect = (int) (0);
 //BA.debugLineNum = 46;BA.debugLine="Dim cstatePreConnect As Int = 1";
_cstatepreconnect = (int) (1);
 //BA.debugLineNum = 47;BA.debugLine="Dim cstateConnect As Int = 2";
_cstateconnect = (int) (2);
 //BA.debugLineNum = 48;BA.debugLine="Dim cstatePreDisconnect As Int = 3";
_cstatepredisconnect = (int) (3);
 //BA.debugLineNum = 50;BA.debugLine="Dim PrivServ As BleService";
_privserv = new anywheresoftware.b4a.objects.BleManager.GattServiceWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Dim CharRead As BleCharacteristic";
_charread = new anywheresoftware.b4a.objects.BleManager.GattCharacteristic();
 //BA.debugLineNum = 52;BA.debugLine="Dim CharWrite As BleCharacteristic";
_charwrite = new anywheresoftware.b4a.objects.BleManager.GattCharacteristic();
 //BA.debugLineNum = 53;BA.debugLine="Dim ReadText As String";
_readtext = "";
 //BA.debugLineNum = 54;BA.debugLine="Dim ReadString As String";
_readstring = "";
 //BA.debugLineNum = 55;BA.debugLine="Dim SendText As String";
_sendtext = "";
 //BA.debugLineNum = 56;BA.debugLine="Dim SendString As String";
_sendstring = "";
 //BA.debugLineNum = 57;BA.debugLine="Dim readHex As Boolean";
_readhex = false;
 //BA.debugLineNum = 58;BA.debugLine="Dim sendHex As Boolean";
_sendhex = false;
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _timer_tick() throws Exception{
 //BA.debugLineNum = 397;BA.debugLine="Sub Timer_Tick";
 //BA.debugLineNum = 398;BA.debugLine="End Sub";
return "";
}
}
